#Test Name: GiaIvinsBenchmarksAB2dA2
from socket import gethostname

import numpy as np

from model import *
from parameterize import *
from setmask import *
from solve import *
from triangle import *


#Benchmark experiments (Figure A2a Ivins and James, 1999, Geophys. J. Int.)
md = triangle(model(), '../Exp/RoundFrontEISMINT.exp', 200000)
md = setmask(md, '', '')
md = parameterize(md, '../Par/GiaIvinsBenchmarksAB.py')

#indicate what you want to compute
md.gia.cross_section_shape = 1  # for square-edged x - section

#define loading history
md.timestepping.start_time = 2005100  # after 5 kyr of deglaciation
md.timestepping.final_time = 2500000  # 2, 500 kyr
md.geometry.thickness = np.array([np.append(md.geometry.thickness * 0.0, 0.0),
                                  np.append(md.geometry.thickness, 1000),
                                  np.append(md.geometry.thickness, 2000000),
                                  np.append(md.geometry.thickness * 0.0, 2000100),
                                  np.append(md.geometry.thickness * 0.0, md.timestepping.start_time)]).T

#solve for GIA deflection
md.cluster = generic('name', gethostname(), 'np', 3)
md.verbose = verbose('1111111')
md = solve(md, 'Gia')

#Fields and tolerances to track changes
field_names = ['Ugia', 'UGiaRate']
field_tolerances = [1e-13, 1e-13]
field_values = [md.results.GiaSolution.UGia, md.results.GiaSolution.UGiaRate]
